unit boxes;
interface

uses allpas;

type str3=string[7];

     m5 = array[1..5] of string[70];


var boxscreen:screenptr; {screenptr is defined in allpas }


function yesnobox(msg:string; s1,s2:str3;k1,k2:char;def:boolean):boolean;
procedure msgbox(msg:string);
procedure multimsgbox(msgs:m5;cent:boolean);
function numbox(min,max,startnum:longint; msg:string):longint;
function textbox(min,max:integer;starttxt,msg:string):string;
function picklite( def:byte; deftext:string;
                   m:m5):byte;

implementation

uses crt,glob,goodunit;

function yesnobox(msg:string; s1,s2:str3;k1,k2:char;def:boolean):boolean;
var a,msglen,sp,sp2:byte;
    ch:char;
    tempstr:string;
    current:boolean;
    saveattr:byte;
begin
  saveattr:=textattr;
  savescreen(boxscreen);
  if length(msg)<11 then msglen:=11 else msglen:=length(msg);
  sp:=((80-msglen) div 2)-3;
  insert('`%',s1,pos(k1,s1)); insert('`7',s1,pos(k1,s1)+1);
  insert('`%',s2,pos(k2,s2)); insert('`7',s2,pos(k2,s2)+1);

  tempstr:=center(s1+'  '+s2,msglen);

  sp2:=pos(s1[1],tempstr);
  current:=def;

 textbackground(0);
 gotoxy(sp,11);
 say(lc+'');
 for a:= 1 to msglen+2 do write('');
 write('');

 gotoxy(sp,12);
 write(' ');
 say('`%'+msg+lc);
 write(' ');

 gotoxy(sp,13);
 write('');
 for a:= 1 to msglen+2 do write(' ');
 write('');

 gotoxy(sp,14);
 write('');
 for a:= 1 to msglen+2 do write(' ');
 write('');


 gotoxy(sp+2,14);
 say('`%'+tempstr);

 gotoxy(sp,15);
 say(lc+'');
 for a:= 1 to msglen+2 do write('');
 write('');

 if current then
 begin
 gotoxy(sp+sp2,14);
 say(hc+'-`%'+s1+hc+'-');
 gotoxy(sp+sp2+6,14);
 say(' `7'+s2+' ');
 end else
 begin
 gotoxy(sp+sp2,14);
 say('`7 '+s1+' ');
 gotoxy(sp+sp2+6,14);
 say(hc+'-`%'+s2+hc+'-');
 end;

repeat
 ch:=readkey;

 if ch in [#75,#77,'4','6'] then current:=not current;

 if ch='4' then ch:=#75 else if ch='6' then ch:=#77;


 if upcase(ch)=upcase(k1) then begin yesnobox:=true; exit; end else
 if upcase(ch)=upcase(k2) then begin yesnobox:=false; exit; end;

 if current then
 begin
 gotoxy(sp+sp2,14);
 say(hc+'-`%'+s1+hc+'-');
 gotoxy(sp+sp2+6,14);
 say(' `7'+s2+' ');
 end else
 begin
 gotoxy(sp+sp2,14);
 say('`7 '+s1+' ');
 gotoxy(sp+sp2+6,14);
 say(hc+'-`%'+s2+hc+'-');
 end;

until ch=#13;
yesnobox:=current;
restorescreen(boxscreen);
textattr := saveattr;
end;

procedure msgbox(msg:string);
var a,msglen,sp:byte;
    ch:char;
    tempstr:string;
begin
  savescreen(boxscreen);

  if length(msg)<13 then
  begin
    msglen:=11;
    while length(msg) < 13 do msg := msg + ' ';
  end
  else
    msglen:=length(msg);

  sp:=((80-msglen) div 2)-3;
  tempstr:=center('<hit a key>',msglen);

  if length(tempstr) > msglen then msglen := length(tempstr);

 gotoxy(sp,11);
 say(lc+'');
 for a:= 1 to msglen+2 do write('');
 write('');

 gotoxy(sp,12);
 write(' ');
 say('`%'+msg+lc);
 write(' ');

 gotoxy(sp,13);
 write('');
 for a:= 1 to msglen+2 do write(' ');
 write('');

 gotoxy(sp,14);
 say(' `%');
 say(tempstr+' '+lc);
 write(' ');

 gotoxy(sp,15);
 say(lc+'');
 for a:= 1 to msglen+2 do write('');
 write('');
 readkey;
restorescreen(boxscreen);
end;


procedure multimsgbox(msgs:m5;cent:boolean);
var a,msglen,sp:byte;
    ch:char;
    tempstr:string;
    bottom:byte;
    found:boolean;
begin
savescreen(boxscreen);

  a := 5;
  found := false;
  bottom := 5;
  while (bottom > 0) and (found=false) do
  begin
    if msgs[bottom]<>'' then found := true
    else dec(bottom);
  end;

  msglen := 11;
  for a := 1 to bottom do
    if length(msgs[a]) > msglen then
      msglen := length(msgs[a]);

  sp:=((80-msglen) div 2)-3;
  tempstr:=center('<hit a key>',msglen);

  gotoxy(sp,11);
  say(lc+'');
  for a:= 1 to msglen+2 do write('');
  write('');

  for a := 1 to bottom do
  begin
    gotoxy(sp,11 + a);
    write(' ');
    if cent then
      say('`%'+center(msgs[a],msglen)+lc)
    else
      say('`%'+msgs[a]+lc);
    write(' ');
  end;

  gotoxy(sp,11 + bottom + 1);
  write('');
  for a:= 1 to msglen+2 do write(' ');
  write('');

  gotoxy(sp,11 + bottom + 2);
  say(' `%');
  say(tempstr+' '+lc);
  write(' ');

  gotoxy(sp,11 + bottom + 3);
  say(lc+'');
  for a:= 1 to msglen+2 do write('');
  write('');
  readkey;

  restorescreen(boxscreen);

end;

function numbox(min,max,startnum:longint; msg:string):longint;
var dc,leng:byte;
    ts,ts1,ts2:string;
begin
  savescreen(boxscreen);
  cursoron;
  leng:=length(msg);
  str(min,ts1);
  str(max,ts2);
  ts:=' '+ts1+' to '+ts2+' ';
  if length(ts)>leng then leng:=length(ts);
  if leng<8 then leng:=8;
  textbackground(0);
  gotoxy((80-leng) div 2,9);
  say(lc+'');
  for dc:= 1 to leng+2 do write('');
  write('');

gotoxy((80-leng) div 2,10);
write(' ');
for dc:= 1 to leng do write(' ');
write(' ');

gotoxy((80-leng) div 2+2,10);
say('`%'+center(msg,leng)+lc);

gotoxy((80-leng) div 2,11);
write(' ');
for dc:= 1 to leng do write(' ');
write(' ');

gotoxy((80-leng) div 2,12);
write(' ');
for dc:= 1 to leng do write(' ');
write(' ');

gotoxy((80-leng) div 2+2,12);
say('`7'+center(ts,leng)+lc);

gotoxy((80-leng) div 2,13);
write(' ');
for dc:= 1 to leng do write(' ');
write(' ');

gotoxy((80-leng) div 2,14);
write(' ');
for dc:= 1 to leng do write(' ');
write(' ');

gotoxy((80-leng) div 2,15);
write('');
for dc:= 1 to leng+2 do write('');
write('');

numbox:=edi_num(((80-length(ts2)) div 2) +1,14,min,max,startnum);
cursoroff;
restorescreen(boxscreen);
end;

function textbox(min,max:integer;starttxt,msg:string):string;
var dc,leng:byte;
    ts,ts1,ts2:string;
begin
  savescreen(boxscreen);
  cursoron;
  leng:=length(msg);
  if length(starttxt) > leng then leng:=length(starttxt);
  if max>leng then leng:=max+2;

  msg := center(msg,leng);
  if length(msg) < leng then
   while length(msg) < leng do
     msg := msg + ' ';

  textbackground(0);
  gotoxy((80-leng) div 2,9);
  say(lc+'');
  for dc:= 1 to leng+2 do write('');
  write('');

gotoxy((80-leng) div 2,10);
say(' `%'+center(msg,leng)+lc+' ');

gotoxy((80-leng) div 2,11);
write(' ');
for dc:= 1 to leng do write(' ');
write(' ');

gotoxy((80-leng) div 2,12);
write(' ');
for dc:= 1 to leng do write(' ');
write(' ');

gotoxy((80-leng) div 2,13);
write('');
for dc:= 1 to leng+2 do write('');
write('');
ts := edi(((80-max) div 2)+1,12,max,1,15,starttxt);
while ts[length(ts)]=' 'do delete(ts,length(ts),1);
textbox:=ts;
cursoroff;
restorescreen(boxscreen);
end;

function picklite( def:byte; deftext:string;
                   m:m5):byte;

type tpoint = record
       x:byte;
       y:byte;
       t:string;
       a:byte;
     end;

var leng : byte;
    points: array[1..5] of tpoint;
    ch:char;
    dc:byte;
    oldcur,
    cur:integer;
    bottom:byte;
begin
  savescreen(boxscreen);


  { first find out where out bottom is}
  dc := 1;
  bottom := 5;
  while (dc=1) do
  begin
    if m[bottom]='' then dec(bottom) else dc := 0;
  end;


  { now set the max length of the litebars}
  leng := length(deftext);

  for dc := 1 to bottom do
  begin
    if length(m[dc]) > leng then leng := length(m[dc]);
  end;


  { now pad the litebars to the maxlength}
  for dc := 1 to bottom do
  begin
    while length(m[dc]) < leng do m[dc] := m[dc] + ' ';
  end;

  textbackground(0);
  gotoxy((80-leng) div 2,9);
  say(lc+'');
  for dc:= 1 to leng+2 do write('');
  write('');

  gotoxy((80-leng) div 2,10);
  say(' `%'+center(deftext,leng)+lc+' ');

  gotoxy((80-leng) div 2,11);
  say(' `%'+center(' ',leng)+lc+' ');

  for dc := 1 to bottom do
  begin
    gotoxy((80-leng) div 2,11+dc);
    write(' ');
    points[dc].x := wherex;
    points[dc].y := wherey;
    points[dc].t := m[dc];
    say('`%'+m[dc]+lc+' ');
  end;

  gotoxy((80-leng) div 2,11+bottom+1);
  write('');
  for dc:= 1 to leng+2 do write('');
  write('');

  cur := def;
  oldcur := -999;

  repeat
    if oldcur <> -999 then
    begin
      gotoxy(points[oldcur].x,points[oldcur].y);
      say('`r0`%'+points[oldcur].t);
    end;

    gotoxy(points[cur].x,points[cur].y);
    say('`r1`%'+points[cur].t);

    oldcur := cur;

    ch := readkey;
    if ch = #0 then ch := readkey;

    case ch of
    #27: cur := def;
    #72: if cur = 1 then cur := bottom else dec(cur);
    #80: if cur = bottom then cur := 1 else inc(cur);
    end; {case}

  until ch in [#13,#27];

  textbackground(0);
  restorescreen(boxscreen);
  if ch = #27 then
    picklite := def
  else
    picklite := cur;
end;


begin
  new(boxscreen);
end.
