unit litebox;
{&Delphi-}

interface

type mrec=record
       skip:boolean;
       name:string;
       letter:char;
     end;

     literec = Record   {Litebar config rec}
       choices: Integer;
       menu: Array [1..25] Of mrec;
       usehotkeys:boolean;
     End;


function litebar (var ff): integer;

implementation
uses crt,goodunit,glob;

Function litebar (var ff): Integer;
Label stop;
Var
  lastone,on2: Integer;
  X, Y: Integer;
  key: Char;          {Various vars}
  okey: Byte;
  litesize: Integer;
  goodkey:boolean;
  fkey:boolean;
  lite: literec absolute ff;

Begin
  X := WhereX;   {Record starting positions}
  Y := WhereY;
  TextBackground (0);            {Change background}
  litesize := 0;
  For on2 := 1 To lite. choices Do Begin  {This for loop writes the options.}
    if lite.menu[on2].skip=false then
    begin
    GotoXY (X, Y + on2 - 1);
    if lite.usehotkeys=true then say(hc+'  (`%'+lite.menu[on2].letter+hc+')');
    say (' `7'+lite. menu[on2].name );
    If Length (lite. menu [on2].name ) > litesize Then litesize := Length(lite. menu [on2].name );
    end;
  End;

  For on2 := 1 To lite. choices Do Begin  {This for loop makes the >lightbar}
    if lite.menu[on2].skip=false then
    begin
    If Length (lite. menu [on2].name ) < litesize Then Begin {the same >length}
      Repeat
        lite. menu [on2].name := lite. menu [on2].name + ' ';
      Until Length (lite. menu [on2].name ) >= litesize;
    end;
    End;
  End;
  if on=-1 then on := 1;
  lastone:=999;
  on2 := on;
  goodkey := false;

  while (on2 <= lite.choices) and (goodkey = false) do
  begin
    if lite.menu[on2].skip = false then goodkey := true
    else inc(on2);
  end;

  on := on2;

  Repeat   {Main loop}
    If lastone <> 999 Then Begin  {redraw last option (reset background}
      gotoxy(x-1,y+lastone-1);
      Write('  ');
    End;
    GotoXY (X-1, Y + on - 1);
    say('`%=>');
    goodkey:=false;
    fkey:=false;
    Repeat  {gets up/down/enter/esc/function or hotkey}
     key := ReadKey;
     if key=#0 then
     begin
     fkey:=true;
     key:=readkey;
     end else key:=upcase(key);   {up,down, and the FKeys}
     if (fkey=true) and (key in [#72,#80,#59..#68])
          then goodkey:=true else
     if key In [#27,#13,'8','2'] then goodkey:=true else
     if lite.usehotkeys=true then
     for okey:= 1 to lite.choices do
      if (key=lite.menu[okey].letter) and (lite.menu[okey].skip=false) then
       begin
        on:=okey;
        goodkey:=true;
        goto stop;
       end;
    until goodkey=true;
    case key of
    #72,'8':  Begin  {up}
                lastone:=on;
                If on = 1 Then
                begin
                  on := lite. choices;
                  while (on in [1..lite.choices]) and (lite.menu[on].skip = true) do
                    dec(on);
                end
                Else
                If on > 1 Then
                begin
                  goodkey:=false;
                  dec(on);
                  while (on in [1..lite.choices]) and (lite.menu[on].skip = true) do
                  begin
                    dec(on);
                    if (on=1) and (lite.menu[on].skip=true) then on := lite.choices
                  end;
                end;
              end;

    #80,'2':  Begin {down}
                lastone:=on;
                If on = lite. choices Then
                Begin
                  on := 1;
                  while (on in [1..lite.choices]) and (lite.menu[on].skip = true) do
                    inc(on);
                end
                Else
                begin
                  inc(on);
                  while (on in [1..lite.choices]) and (lite.menu[on].skip = true) do
                  begin
                    inc(on);
                    if (on=lite.choices) and (lite.menu[on].skip = true) then on := 1;
                  end;
                end;
              End;

     #13 : goto stop;
     #27: begin   lastone:=on;on:=lite.choices; goto stop; end;
     #59: begin   lastone:=on;on:=-1; goto stop; end;
     #60: begin   lastone:=on;on:=-2; goto stop; end;
     #61: begin   lastone:=on;on:=-3; goto stop; end;
     #62: begin   lastone:=on;on:=-4; goto stop; end;
     #63: begin   lastone:=on;on:=-5; goto stop; end;
     #64: begin   lastone:=on;on:=-6; goto stop; end;
     #65: begin   lastone:=on;on:=-7; goto stop; end;
     #66: begin   lastone:=on;on:=-8; goto stop; end;
     #67: begin   lastone:=on;on:=-9; goto stop; end;
     #68: begin   lastone:=on;on:=-10; goto stop; end;

      end;{case}


  Until 5 < 4; {loop.}
  stop:  {end it}
  litebar := on;  {tell us what they picked}
End;


BEGIN
END.
